var mapExec = {
	_stopEvent:function(e){
		if (e.stopPropagation) {
		      e.stopPropagation();
		      e.preventDefault();
		    } else {
		      e.cancelBubble = true;
		      e.returnValue = false;
		    }
	},
	_loadMap:function(item){
			if(item.society != null){
				var infocontent = '<strong>'+item.society+'</strong>'+'<br />'+item.adress+'<br />'+item.city+'<br />'+item.country;
			}else{
				var infocontent = item.adress+'<br />'+item.city+'<br />'+item.country;
			}
			var pos = [item.lat,item.lng];
		    $('#map_adress').gmap3(
		    	{
		            action: 'addMarker',
		            latLng: pos,
		            map:{
		                center: true,
		                zoom: 15,
		                mapTypeId: google.maps.MapTypeId.ROADMAP
		            },marker:{
		            	options:{
		            		draggable: false,
		            		icon:new google.maps.MarkerImage("/plugins/gmap/markers/"+item.marker)
		            	}
		            },infowindow:{
		                options:{
		                  size: new google.maps.Size(20,20),
		                  content: infocontent
		                }
		            }
		        },
			  { action:'addDirectionsRenderer',
			    options:{
			        preserveViewport: true,
			        draggable: true
			    }
			  }
			);
	},
	_getDirection:function(item){
		if(item.route == '1'){
			$('.subdirection:button').live('click',function(event){
				mapExec._stopEvent(event);
		    	if($('#getadress').val().length != 0 && $('#getcity').val().length != 0){
		        	$('#map_adress').width(420).height(400).css({marginLeft:'5px'});
		        	$('#r-directions').animate({
		        	    width: '280',
		        	    height: '400'
		        	  }, 800);
					  $('#map_adress').gmap3(
						{action:'clear'},
						{ 
					    action:'getRoute',
					    options:{
					    	origin:item.adress+' '+item.city+','+item.country,
					        destination:$('#getadress').val()+','+$('#getcity').val(),
					        travelMode: google.maps.DirectionsTravelMode.DRIVING
					    },
					    callback: function(results){
					      $(this).gmap3({
					        action:'setDirections', 
					        directions: results
					      },{
				    	      action:'setDirectionsPanel', 
				    	      id: 'r-directions'
				    	    });
					    }
					  });
		    	}
			});
		}
	},
	_jsondata:function(){
		$.ajax({
			url: '/magixmod/gmap/jsondata/',
			dataType: 'json',
			type: "get",
			statusCode: {
				0: function() {
					console.error("jQuery Error");
				},
				401: function() {
					console.warn("access denied");
				},
				404: function() {
					console.warn("object not found");
				},
				403: function() {
					console.warn("request forbidden");
				},
				408: function() {
					console.warn("server timed out waiting for request");
				},
				500: function() {
					console.error("Internal Server Error");
				}
			},
			async: true,
			cache:false,
			beforeSend: function(){
				$('#map_adress').html('<img class="map_loader" src="/plugins/gmap/img/ajax-loader.gif" />');
			},
			success: function(j) {
				$('#map_adress').empty();
				if(j === undefined){
					console.log(j);
					$('#map_adress').text("map is undefined");
				}
				if(j !== null){
					$.each(j, function(i,item) {
						if(item.lat != null && item.lng != null){
							mapExec._loadMap(item);
							if(item.adress != null && item.city != null){
								mapExec._getDirection(item);
							}
						}
					});
				}
			}
		});
	}
};